define(["app", "js/countModel", "js/countEdit/countEditView"], function(app, Count, View) {

	var count = null;
	var state = {
		isNew: false
	};
	var bindings = [{
		element: '.count-delete-button',
		event: 'click',
		handler: deleteCount
	}];

	 $(document).ready(function() {

	function autoCalcSetup() {
                    $('form[name=cash]').jAutoCalc('destroy');
                    $('form[name=cash] tr[name=line_items]').jAutoCalc({keyEventsFire: true, decimalPlaces: 2, emptyAsZero: true});
                    $('form[name=cash]').jAutoCalc({decimalPlaces: 2});
		}
			autoCalcSetup();

	});

	function init(query){
		var counts = JSON.parse(localStorage.getItem("f7Counts"));
		if (query && query.id) {
			count = new Count(_.find(counts, { id: query.id }));
			state.isNew = false;
		}
		else {
			count = new Count({ isCup: query.isCup });
			state.isNew = true;
		}
		View.render({ model: count, bindings: bindings, state: state, doneCallback: saveCount });
	}

	function deleteCount() {
		app.f7.actions([[{
			text: '<div class="float-buttonc" style="bottom:80px;"><div class="inside"><i class="icon simbicon-trash"></i></div></div>',
			red: true,
			onClick: function() {
				var counts = JSON.parse(localStorage.getItem("f7Counts"));
				_.remove(counts, { id: count.id });
				localStorage.setItem("f7Counts", JSON.stringify(counts));
				app.router.load('list'); // reRender main page view
				app.mainView.goBack("index.html", false);
				app.f7.closeModal();
			}
		}], [{
			text: '<div class="float-buttonc"><div class="inside"><i class="icon simbicon-close"></i></div></div>',
			bold: true
		}]]);
	}

	function saveCount(inputValues) {
		count.setValues(inputValues);
		if (!count.validate()) {
			app.f7.alert("El Nombre y la Fecha no pueden estar vacios");
			return;
		}

		var counts = JSON.parse(localStorage.getItem("f7Counts"));
		if (!state.isNew) {
			_.remove(counts, { id: count.id });
		}
		counts.push(count);
		localStorage.setItem("f7Counts", JSON.stringify(counts));
		app.router.load('list'); // reRender main page view
		closePage();
	}

	function closePage() {
		if (!state.isNew) {
			app.router.load('count', {id: count.id});
		}
		else {
			app.mainView.loadPage('count.html?id=' + count.id, false);
		}
		app.f7.closeModal();
	}

	return {
		init: init
	};
});
